Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | List of all members
Botan::CBC_Decryption Class Reference

`#include <cbc.h>`

Inheritance diagram for Botan::CBC_Decryption:

## Public Member Functions
virtual bool | authenticated () const
| CBC_Decryption (BlockCipher *cipher, BlockCipherModePaddingMethod *padding)
void | clear () override
size_t | default_nonce_length () const override
void | finish (secure_vector< uint8_t > &final_block, size_t offset=0) override
Key_Length_Specification | key_spec () const override
size_t | minimum_final_size () const override
std::string | name () const override
size_t | output_length (size_t input_length) const override
size_t | process (uint8_t buf[], size_t size) override
virtual std::string | provider () const
void | reset () override
template<typename Alloc >
void | set_key (const std::vector< uint8_t, Alloc > &key)
void | set_key (const SymmetricKey &key)
void | set_key (const uint8_t key[], size_t length)
template<typename Alloc >
void | start (const std::vector< uint8_t, Alloc > &nonce)
void | start (const uint8_t nonce[], size_t nonce_len)
void | start ()
virtual size_t | tag_size () const
void | update (secure_vector< uint8_t > &buffer, size_t offset=0)
size_t | update_granularity () const override
bool | valid_keylength (size_t length) const
bool | valid_nonce_length (size_t n) const override

## Protected Member Functions
const BlockCipher & | cipher () const
const BlockCipherModePaddingMethod & | padding () const
secure_vector< uint8_t > & | state ()
uint8_t * | state_ptr ()

## Detailed Description

CBC Decryption

Definition at line 108 of file cbc.h.

## Constructor & Destructor Documentation

Botan::CBC_Decryption::CBC_Decryption | ( | BlockCipher * | cipher,
|  | BlockCipherModePaddingMethod * | padding
| ) |  |
| inline

Parameters

  cipher | block cipher to use
  padding | padding method to use

Definition at line 115 of file cbc.h.

115 :
116 CBC_Mode(cipher, padding), m_tempbuf(update_granularity()) {}
Botan::CBC_Mode::update_granularity
size_t update_granularity() const override
Definition: cbc.cpp:45
Botan::CBC_Mode::CBC_Mode
CBC_Mode(BlockCipher *cipher, BlockCipherModePaddingMethod *padding)
Definition: cbc.cpp:15
Botan::CBC_Mode::padding
const BlockCipherModePaddingMethod & padding() const
Definition: cbc.h:43
Botan::CBC_Mode::cipher
const BlockCipher & cipher() const
Definition: cbc.h:41

## Member Function Documentation

virtual bool Botan::Cipher_Mode::authenticated | ( |  | ) | const
| inline virtual inherited

Returns
  true iff this mode provides authentication as well as confidentiality.

Reimplemented in Botan::AEAD_Mode.

Definition at line 145 of file cipher_mode.h.

145 { return false; }

const BlockCipher& Botan::CBC_Mode::cipher | ( |  | ) | const
| inline protected inherited

Definition at line 41 of file cbc.h.

Referenced by Botan::CBC_Mode::default_nonce_length(), Botan::CBC_Encryption::finish(), Botan::CTS_Encryption::finish(), finish(), Botan::CTS_Decryption::finish(), Botan::CBC_Mode::key_spec(), Botan::CTS_Encryption::minimum_final_size(), minimum_final_size(), Botan::CTS_Decryption::minimum_final_size(), Botan::CBC_Mode::name(), Botan::CBC_Encryption::output_length(), Botan::CBC_Encryption::process(), process(), Botan::CBC_Mode::update_granularity(), Botan::CBC_Mode::valid_nonce_length(), Botan::CTS_Encryption::valid_nonce_length(), and Botan::CTS_Decryption::valid_nonce_length().

41 { return *m_cipher; }

void Botan::CBC_Mode::clear | ( |  | ) |
| override virtual inherited

Zeroise all state See also reset_msg()

Implements Botan::Cipher_Mode.

Definition at line 26 of file cbc.cpp.

References Botan::CBC_Mode::reset().

27 {
28 m_cipher->clear();
29 reset();
30 }
Botan::CBC_Mode::reset
void reset() override
Definition: cbc.cpp:32

size_t Botan::CBC_Mode::default_nonce_length | ( |  | ) | const
| override virtual inherited

Returns
  the default size for a nonce

Implements Botan::Cipher_Mode.

Definition at line 55 of file cbc.cpp.

References Botan::BlockCipher::block_size(), and Botan::CBC_Mode::cipher().

56 {
57 return cipher().block_size();
58 }
Botan::CBC_Mode::cipher
const BlockCipher & cipher() const
Definition: cbc.h:41
Botan::BlockCipher::block_size
virtual size_t block_size() const =0

void Botan::CBC_Decryption::finish | ( | secure_vector< uint8_t > & | final_block,
|  | size_t | offset = `0`
| ) |  |
| override virtual

Complete processing of a message.

Parameters

  final_block | in/out parameter which must be at least minimum_final_size() bytes, and will be set to any final output
  offset | an offset into final_block to begin processing

Implements Botan::Cipher_Mode.

Reimplemented in Botan::CTS_Decryption.

Definition at line 232 of file cbc.cpp.

References Botan::BlockCipher::block_size(), BOTAN_ASSERT, Botan::CBC_Mode::cipher(), Botan::CBC_Mode::name(), Botan::BlockCipherModePaddingMethod::name(), Botan::CBC_Mode::padding(), Botan::BlockCipherModePaddingMethod::unpad(), and Botan::Cipher_Mode::update().

233 {
234 BOTAN_ASSERT(buffer.size() >= offset, "Offset is sane");
235 const size_t sz = buffer.size() - offset;
236
237 const size_t BS = cipher().block_size();
238
239 if(sz == 0 || sz % BS)
240 throw Decoding_Error(name() + ": Ciphertext not a multiple of block size");
241
242 update(buffer, offset);
243
244 const size_t pad_bytes = BS - padding().unpad(&buffer[buffer.size()-BS], BS);
245 buffer.resize(buffer.size() - pad_bytes); // remove padding
246 if(pad_bytes == 0 && padding().name() != "NoPadding")
247 {
248 throw Decoding_Error(name());
249 }
250 }
Botan::CBC_Mode::name
std::string name() const override
Definition: cbc.cpp:37
Botan::Cipher_Mode::update
void update(secure_vector< uint8_t > &buffer, size_t offset=0)
Definition: cipher_mode.h:81
Botan::CBC_Mode::padding
const BlockCipherModePaddingMethod & padding() const
Definition: cbc.h:43
BOTAN_ASSERT
#define BOTAN_ASSERT(expr, assertion_made)
Definition: assert.h:27
Botan::CBC_Mode::cipher
const BlockCipher & cipher() const
Definition: cbc.h:41
Botan::BlockCipherModePaddingMethod::unpad
virtual size_t unpad(const uint8_t block[], size_t size) const =0
Botan::BlockCipherModePaddingMethod::name
virtual std::string name() const =0
Botan::BlockCipher::block_size
virtual size_t block_size() const =0

Key_Length_Specification Botan::CBC_Mode::key_spec | ( |  | ) | const
| override virtual inherited

Returns
  object describing limits on key size

Implements Botan::Cipher_Mode.

Definition at line 50 of file cbc.cpp.

References Botan::CBC_Mode::cipher(), and Botan::SymmetricAlgorithm::key_spec().

51 {
52 return cipher().key_spec();
53 }
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0
Botan::CBC_Mode::cipher
const BlockCipher & cipher() const
Definition: cbc.h:41

size_t Botan::CBC_Decryption::minimum_final_size | ( |  | ) | const
| override virtual

Returns
  required minimium size to finalize() - may be any length larger than this.

Implements Botan::Cipher_Mode.

Reimplemented in Botan::CTS_Decryption.

Definition at line 201 of file cbc.cpp.

References Botan::BlockCipher::block_size(), and Botan::CBC_Mode::cipher().

202 {
203 return cipher().block_size();
204 }
Botan::CBC_Mode::cipher
const BlockCipher & cipher() const
Definition: cbc.h:41
Botan::BlockCipher::block_size
virtual size_t block_size() const =0

std::string Botan::CBC_Mode::name | ( |  | ) | const
| override virtual inherited

Implements Botan::Cipher_Mode.

Definition at line 37 of file cbc.cpp.

References Botan::CBC_Mode::cipher(), Botan::BlockCipherModePaddingMethod::name(), Botan::SymmetricAlgorithm::name(), and Botan::CBC_Mode::padding().

Referenced by Botan::CBC_Encryption::finish(), Botan::CTS_Encryption::finish(), finish(), and Botan::CTS_Decryption::finish().

38 {
39 if(m_padding)
40 return cipher().name() + "/CBC/" + padding().name();
41 else
42 return cipher().name() + "/CBC/CTS";
43 }
Botan::CBC_Mode::padding
const BlockCipherModePaddingMethod & padding() const
Definition: cbc.h:43
Botan::SymmetricAlgorithm::name
virtual std::string name() const =0
Botan::CBC_Mode::cipher
const BlockCipher & cipher() const
Definition: cbc.h:41
Botan::BlockCipherModePaddingMethod::name
virtual std::string name() const =0

size_t Botan::CBC_Decryption::output_length | ( | size_t | input_length | ) | const
| override virtual

Returns the size of the output if this transform is used to process a message with input_length bytes. Will throw if unable to give a precise answer.

Implements Botan::Cipher_Mode.

Definition at line 196 of file cbc.cpp.

197 {
198 return input_length; // precise for CTS, worst case otherwise
199 }

const BlockCipherModePaddingMethod& Botan::CBC_Mode::padding | ( |  | ) | const
| inline protected inherited

Definition at line 43 of file cbc.h.

References BOTAN_ASSERT_NONNULL.

Referenced by Botan::CBC_Encryption::finish(), finish(), and Botan::CBC_Mode::name().

44 {
45 BOTAN_ASSERT_NONNULL(m_padding);
46 return *m_padding;
47 }
BOTAN_ASSERT_NONNULL
#define BOTAN_ASSERT_NONNULL(ptr)
Definition: assert.h:79

size_t Botan::CBC_Decryption::process | ( | uint8_t | msg[],
|  | size_t | msg_len
| ) |  |
| override virtual

Process message blocks

Input must be a multiple of update_granularity

Processes msg in place and returns bytes written. Normally this will be either msg_len (indicating the entire message was processed) or for certain AEAD modes zero (indicating that the mode requires the entire message be processed in one pass).

Parameters

  msg | the message to be processed
  msg_len | length of the message in bytes

Implements Botan::Cipher_Mode.

Definition at line 206 of file cbc.cpp.

References Botan::BlockCipher::block_size(), BOTAN_ASSERT, Botan::CBC_Mode::cipher(), Botan::copy_mem(), Botan::BlockCipher::decrypt_n(), Botan::CT::min(), Botan::CBC_Mode::state_ptr(), and Botan::xor_buf().

207 {
208 const size_t BS = cipher().block_size();
209
210 BOTAN_ASSERT(sz % BS == 0, "Input is full blocks");
211 size_t blocks = sz / BS;
212
213 while(blocks)
214 {
215 const size_t to_proc = std::min(BS * blocks, m_tempbuf.size());
216
217 cipher().decrypt_n(buf, m_tempbuf.data(), to_proc / BS);
218
219 xor_buf(m_tempbuf.data(), state_ptr(), BS);
220 xor_buf(&m_tempbuf[BS], buf, to_proc - BS);
221 copy_mem(state_ptr(), buf + (to_proc - BS), BS);
222
223 copy_mem(buf, m_tempbuf.data(), to_proc);
224
225 buf += to_proc;
226 blocks -= to_proc / BS;
227 }
228
229 return sz;
230 }
Botan::xor_buf
void xor_buf(T out[], const T in[], size_t length)
Definition: mem_ops.h:115
Botan::BlockCipher::decrypt_n
virtual void decrypt_n(const uint8_t in[], uint8_t out[], size_t blocks) const =0
BOTAN_ASSERT
#define BOTAN_ASSERT(expr, assertion_made)
Definition: assert.h:27
Botan::CBC_Mode::state_ptr
uint8_t * state_ptr()
Definition: cbc.h:51
Botan::copy_mem
void copy_mem(T *out, const T *in, size_t n)
Definition: mem_ops.h:68
Botan::CBC_Mode::cipher
const BlockCipher & cipher() const
Definition: cbc.h:41
Botan::CT::min
T min(T a, T b)
Definition: ct_utils.h:180
Botan::BlockCipher::block_size
virtual size_t block_size() const =0

virtual std::string Botan::Cipher_Mode::provider | ( |  | ) | const
| inline virtual inherited

Returns
  provider information about this implementation. Default is "base", might also return "sse2", "avx2", "openssl", or some other arbitrary string.

Reimplemented in Botan::GCM_Mode.

Definition at line 202 of file cipher_mode.h.

202 { return "base"; }

void Botan::CBC_Decryption::reset | ( |  | ) |
| override virtual

Resets just the message specific state and allows encrypting again under the existing key

Reimplemented from Botan::CBC_Mode.

Definition at line 252 of file cbc.cpp.

References Botan::CBC_Mode::state(), and Botan::zeroise().

253 {
254 zeroise(state());
255 zeroise(m_tempbuf);
256 }
Botan::CBC_Mode::state
secure_vector< uint8_t > & state()
Definition: cbc.h:49
Botan::zeroise
void zeroise(std::vector< T, Alloc > &vec)
Definition: secmem.h:211
template<typename Alloc >

void Botan::Cipher_Mode::set_key | ( | const std::vector< uint8_t, Alloc > & | key | ) |
| inline inherited

Set the symmetric key of this transform

Parameters

  key | contains the key material

Definition at line 172 of file cipher_mode.h.

Referenced by botan_cipher_set_key().

173 {
174 set_key(key.data(), key.size());
175 }
Botan::Cipher_Mode::set_key
void set_key(const std::vector< uint8_t, Alloc > &key)
Definition: cipher_mode.h:172

void Botan::Cipher_Mode::set_key | ( | const SymmetricKey & | key | ) |
| inline inherited

Set the symmetric key of this transform

Parameters

  key | contains the key material

Definition at line 181 of file cipher_mode.h.

References Botan::OctetString::begin(), and Botan::OctetString::length().

182 {
183 set_key(key.begin(), key.length());
184 }
Botan::Cipher_Mode::set_key
void set_key(const std::vector< uint8_t, Alloc > &key)
Definition: cipher_mode.h:172

void Botan::Cipher_Mode::set_key | ( | const uint8_t | key[],
|  | size_t | length
| ) |  |
| inline inherited

Set the symmetric key of this transform

Parameters

  key | contains the key material
  length | in bytes of key param

Definition at line 191 of file cipher_mode.h.

192 {
193 if(!valid_keylength(length))
194 throw Invalid_Key_Length(name(), length);
195 key_schedule(key, length);
196 }
Botan::Cipher_Mode::name
virtual std::string name() const =0
Botan::Cipher_Mode::valid_keylength
bool valid_keylength(size_t length) const
Definition: cipher_mode.h:162
template<typename Alloc >

void Botan::Cipher_Mode::start | ( | const std::vector< uint8_t, Alloc > & | nonce | ) |
| inline inherited

Begin processing a message.

Parameters

  nonce | the per message nonce

Definition at line 38 of file cipher_mode.h.

Referenced by botan_cipher_start(), and Botan::TLS::write_record().

39 {
40 start_msg(nonce.data(), nonce.size());
41 }
Botan::Cipher_Mode::start_msg
virtual void start_msg(const uint8_t nonce[], size_t nonce_len)=0

void Botan::Cipher_Mode::start | ( | const uint8_t | nonce[],
|  | size_t | nonce_len
| ) |  |
| inline inherited

Begin processing a message.

Parameters

  nonce | the per message nonce
  nonce_len | length of nonce

Definition at line 48 of file cipher_mode.h.

49 {
50 start_msg(nonce, nonce_len);
51 }
Botan::Cipher_Mode::start_msg
virtual void start_msg(const uint8_t nonce[], size_t nonce_len)=0

void Botan::Cipher_Mode::start | ( |  | ) |
| inline inherited

Begin processing a message.

Definition at line 56 of file cipher_mode.h.

57 {
58 return start_msg(nullptr, 0);
59 }
Botan::Cipher_Mode::start_msg
virtual void start_msg(const uint8_t nonce[], size_t nonce_len)=0

secure_vector<uint8_t>& Botan::CBC_Mode::state | ( |  | ) |
| inline protected inherited

Definition at line 49 of file cbc.h.

Referenced by Botan::CBC_Encryption::process(), and reset().

49 { return m_state; }

uint8_t* Botan::CBC_Mode::state_ptr | ( |  | ) |
| inline protected inherited

Definition at line 51 of file cbc.h.

Referenced by Botan::CTS_Encryption::finish(), Botan::CTS_Decryption::finish(), Botan::CBC_Encryption::process(), and process().

51 { return m_state.data(); }

virtual size_t Botan::Cipher_Mode::tag_size | ( |  | ) | const
| inline virtual inherited

Returns
  the size of the authentication tag used (in bytes)

Reimplemented in Botan::SIV_Mode, Botan::CCM_Mode, Botan::OCB_Mode, Botan::TLS::TLS_CBC_HMAC_AEAD_Mode, Botan::ChaCha20Poly1305_Mode, Botan::GCM_Mode, and Botan::EAX_Mode.

Definition at line 150 of file cipher_mode.h.

Referenced by botan_cipher_get_tag_length().

150 { return 0; }

void Botan::Cipher_Mode::update | ( | secure_vector< uint8_t > & | buffer,
|  | size_t | offset = `0`
| ) |  |
| inline inherited

Process some data. Input must be in size update_granularity() uint8_t blocks.

Parameters

  buffer | in/out parameter which will possibly be resized
  offset | an offset into blocks to begin processing

Definition at line 81 of file cipher_mode.h.

References BOTAN_ASSERT.

Referenced by botan_cipher_update(), Botan::XTS_Encryption::finish(), Botan::ChaCha20Poly1305_Encryption::finish(), Botan::CBC_Encryption::finish(), Botan::CFB_Encryption::finish(), Botan::EAX_Encryption::finish(), Botan::XTS_Decryption::finish(), Botan::CFB_Decryption::finish(), Botan::CTS_Encryption::finish(), finish(), Botan::TLS::TLS_CBC_HMAC_AEAD_Encryption::finish(), Botan::CTS_Decryption::finish(), and Botan::TLS::TLS_CBC_HMAC_AEAD_Decryption::finish().

82 {
83 BOTAN_ASSERT(buffer.size() >= offset, "Offset ok");
84 uint8_t* buf = buffer.data() + offset;
85 const size_t buf_size = buffer.size() - offset;
86
87 const size_t written = process(buf, buf_size);
88 buffer.resize(offset + written);
89 }
BOTAN_ASSERT
#define BOTAN_ASSERT(expr, assertion_made)
Definition: assert.h:27
Botan::Cipher_Mode::process
virtual size_t process(uint8_t msg[], size_t msg_len)=0

size_t Botan::CBC_Mode::update_granularity | ( |  | ) | const
| override virtual inherited

Returns
  size of required blocks to update

Implements Botan::Cipher_Mode.

Definition at line 45 of file cbc.cpp.

References Botan::CBC_Mode::cipher(), and Botan::BlockCipher::parallel_bytes().

46 {
47 return cipher().parallel_bytes();
48 }
Botan::BlockCipher::parallel_bytes
size_t parallel_bytes() const
Definition: block_cipher.h:62
Botan::CBC_Mode::cipher
const BlockCipher & cipher() const
Definition: cbc.h:41

bool Botan::Cipher_Mode::valid_keylength | ( | size_t | length | ) | const
| inline inherited

Check whether a given key length is valid for this algorithm.

Parameters

  length | the key length to be checked.

Returns
  true if the key length is valid.

Definition at line 162 of file cipher_mode.h.

163 {
164 return key_spec().valid_keylength(length);
165 }
Botan::Key_Length_Specification::valid_keylength
bool valid_keylength(size_t length) const
Definition: key_spec.h:51
Botan::Cipher_Mode::key_spec
virtual Key_Length_Specification key_spec() const =0

bool Botan::CBC_Mode::valid_nonce_length | ( | size_t | nonce_len | ) | const
| override virtual inherited

Returns
  true iff nonce_len is a valid length for the nonce

Implements Botan::Cipher_Mode.

Reimplemented in Botan::CTS_Decryption, and Botan::CTS_Encryption.

Definition at line 60 of file cbc.cpp.

References Botan::CBC_Mode::cipher().

61 {
62 return (n == 0 || n == cipher().block_size());
63 }
Botan::CBC_Mode::cipher
const BlockCipher & cipher() const
Definition: cbc.h:41

The documentation for this class was generated from the following files:

- src/lib/modes/cbc/cbc.h
- src/lib/modes/cbc/cbc.cpp